Plugin.extend({
    _type: 'org.ekstep.progressbar',
    _render: true,
    _isContainer: true,
    _stageId: 0,
    _socreInstance: {},
    initPlugin: function(data) {
        this._data = data;
        var dims = this.relativeDims();
        this._self = new createjs.Container();
        this._self.x = dims.x;
        this._self.y = dims.y;
        this._self.w = dims.w;
        this._self.h = dims.h;
        var instance = this;

        var groupObj1 = {
            "x": 5,
            "y": data.y,
            "w": 98,
            "h": 100,
            "shape": [],
            "text": {}
        }
        var groupObj2 = {
            "x": 90,
            "y": data.y,
            "w": 2,
            "h": 100,
            "text": {}
        }
        var shapeW = data.w / data.questions;


        /* For loop to create multiple objects with data to create shape */
        for (var i = 0; i < data.questions; i++) {
            var shapeData = {
                id: "shape" + i,
                x: i * shapeW,
                y: 0,
                h: 100,
                w: shapeW,
                stroke: data.progressbarStroke,
                fill: "#ddd"
            }
            groupObj1.shape.push(shapeData);

        }

        var assessData = [];

        /*Loop to get the latest OE_ASSESS telemetery
            data for each question*/
        var progressbarObject = this._theme.getParam("progressbarObj");
        var currentStageid = this._theme._currentStage;

        if (_.isUndefined(progressbarObject)) {
            var obj = {};
            obj[currentStageid] = [];
            this._theme.setParam("progressbarObj", obj);
        } else {
            if (_.isUndefined(progressbarObject[currentStageid])) {
                progressbarObject[currentStageid] = [];
            } else {
                assessData = progressbarObject[currentStageid];
            }
        }
        addProgress(instance);

        var fontsize = String(data.fontSize / 16 + "em");
        var textObj = {};
        textObj.id = "itemTextId";
        textObj.align = "left";
        textObj.valign = "center";
        textObj.color = "#4c4c4c";
        textObj.fontsize = fontsize;
        textObj.w = 100 - data.w;
        textObj.x = data.w + 1;
        textObj.y = 0;
        textObj.h = 100;
        textObj.zindex = 9999;
        groupObj2.text = textObj;

        var attemptedQuestions = assessData.length;
        groupObj2.text.$t = attemptedQuestions + "/" + data.questions;
        instance._socreInstance = PluginManager.invoke('g', groupObj2, instance, instance, instance._theme);
        Renderer.update = true;


        function getOEAssessData() {
            EkstepRendererAPI.removeChild(instance.id, Renderer.theme._currentScene)
            EventBus.addEventListener("telemetryEvent", function(telemetryData) {

                var teleObj = _.isString(telemetryData.target) ? JSON.parse(telemetryData.target) : telemetryData.target;
                if (teleObj.eid == "ASSESS") {
                    progressbarObject = instance._theme.getParam("progressbarObj");
                    currentStageid = instance._theme._currentStage;
                    if (_.isUndefined(progressbarObject)) {
                        var obj = {};
                        obj[currentStageid] = [];
                        instance._theme.setParam("progressbarObj", obj);
                    } else {
                        if (_.isUndefined(progressbarObject[currentStageid])) {
                            progressbarObject[currentStageid] = [];
                        } else {
                            assessData = progressbarObject[currentStageid];
                        }
                    }
                    var count = 0;
                    if (assessData.length == 0) {
                        assessData.push(teleObj);
                    } else {
                        for (var n = 0; n < assessData.length; n++) {
                            if (assessData[n].edata.item.id == teleObj.edata.item.id) {
                                assessData[n] = teleObj;
                                count++;
                            }
                        }

                        if (count == 0) {
                            assessData.push(teleObj);
                        }
                    }
                    if (!_.isUndefined(progressbarObject)) {
                        progressbarObject[currentStageid] = assessData;
                        var progressObj = JSON.parse(JSON.stringify(progressbarObject));
                        instance._theme.setParam("progressbarObj", progressObj);
                    }

                    var attemptedQuestions;
                    var attemptedQuestions = assessData.length;
                    _.where(instance._socreInstance._self.children, { id: "itemTextId" })[0].text = attemptedQuestions + "/" + data.questions;
                    addProgress(instance);
                }
            })
        }

        function addProgress(instance) {
            var progressData = instance._theme.getParam("progressbarObj");
            var stageProgData = progressData && progressData[instance._theme._currentStage];
            if (stageProgData && (stageProgData.length > 0)) {
                /*Sorting OE_ASSESS/ASSESS arrary based on createdtime and checking answer to show the progressbar*/
                _.sortBy(stageProgData, 'createdTime');
                for (var i = 0; i < stageProgData.length; i++) {
                    if (stageProgData[i].edata.pass == "Yes") {
                        groupObj1.shape[i].fill = instance._data.progressbarSuccess;
                    } else if (assessData[i].edata.pass == "No") {
                        groupObj1.shape[i].fill = instance._data.progressbarFailure;
                    }
                }
            }

            PluginManager.invoke('g', groupObj1, instance, instance._stage, instance._theme);
            Renderer.update = true;
        }

        setTimeout(function() {
            getOEAssessData();
        }, 500);
    }
});
//# sourceURL=progressbarRendererPlugin.js